<?php

namespace STM\Prediction;

use STM\StmFactory;
use STM\Match\Match;
use \Exception;

/**
 * Test class for Prediction.
 * Generated by PHPUnit on 2011-12-03 at 15:52:34.
 * @group prediction
 */
class PredictionTest extends \PHPUnit_Framework_TestCase {

    private $bad_values;
    private $all_predictions;

    protected function setUp() {
        $this->bad_values = array('', null, false, array(), new Exception());
        $users = StmFactory::find()->User->findAll();
        $this->all_predictions = array();
        foreach ($users as $user) {
            $this->all_predictions[] = StmFactory::find()->Prediction->findByUser($user);
        }
    }

    public function testCreate() {
        foreach ($this->bad_values as $value) {
            PredictionValidator::init();
            $this->assertFalse(PredictionValidator::checkCreate($value));
            PredictionValidator::init();
            $this->assertFalse(PredictionValidator::checkCreate(array($value)));
        }
        // rest in PredictionValidatorTest
    }

    public function testUpdate_score() {
        foreach ($this->all_predictions as $users_predictions) {
            foreach ($users_predictions as $prediction) {
                PredictionValidator::setPrediction($prediction);
                foreach ($this->bad_values as $value) {
                    // argument must be array('score_home' => ...., 'score_away' => ...)
                    PredictionValidator::init();
                    $this->assertFalse(PredictionValidator::checkUpdateScore($value));
                }
            }
        }
        // rest in PeriodValidatorTest
    }

    public function testGet_id_user() {
        foreach ($this->all_predictions as $users_predictions) {
            foreach ($users_predictions as $prediction) {
                $this->assertTrue(is_int($prediction->getIdUser()));
            }
        }
    }

    public function testGet_id_match() {
        foreach ($this->all_predictions as $users_predictions) {
            foreach ($users_predictions as $prediction) {
                $this->assertTrue(is_int($prediction->getIdMatch()));
            }
        }
    }

    public function testGet_score_home() {
        foreach ($this->all_predictions as $users_predictions) {
            foreach ($users_predictions as $prediction) {
                $this->assertTrue(is_int($prediction->getScoreHome()));
            }
        }
    }

    public function testGet_score_away() {
        foreach ($this->all_predictions as $users_predictions) {
            foreach ($users_predictions as $prediction) {
                $this->assertTrue(is_int($prediction->getScoreAway()));
            }
        }
    }

    public function testGet_predicted_match() {
        foreach ($this->all_predictions as $users_predictions) {
            foreach ($users_predictions as $prediction) {
                $this->assertTrue($prediction->getPredictedMatch() instanceof Match);
            }
        }
    }

    public function testTo_array() {
        foreach ($this->all_predictions as $users_predictions) {
            foreach ($users_predictions as $prediction) {
                $array = $prediction->toArray();
                $this->assertArrayHasKey('id_user', $array);
                $this->assertArrayHasKey('id_match', $array);
                $this->assertArrayHasKey('score_home', $array);
                $this->assertArrayHasKey('score_away', $array);
            }
        }
    }

    public function test__toString() {
        foreach ($this->all_predictions as $users_predictions) {
            foreach ($users_predictions as $prediction) {
                $this->assertTrue(is_string($prediction->__toString()));
            }
        }
    }

}

?>
